{% extends 'todo/base.html' %}
{% load static %}

{% block content %}
    {% csrf_token %}
    {% if not xhr %}
    <input class="hidden" id="dom_list_id" value="{{ list.id }}">
    <input class="hidden" id="dom_ispublicjs" value="{{ publicjs }}">
    <div class="todo-header" style="max-width: 40em; margin: auto;" id="todo_header">
        <h1>{{ list.title }}</h1>
        <p>Crée par <b>{{ list.owner }}</b> le {{ list.creation_date|date:"d/m/Y à H:i" }}</p>
        <div>
            {{ list.description|display_urls|linebreaks }}
        </div>
        {% if not public %}
        <div>
            <button class="pure-button" id="add-task-btn" type="button" onclick="toggle_add_form('add-container', 'add-task-btn');">Ajouter une tâche</button>
            <button class="no-mob-btn pure-button" id="add-category-form-btn" type="button">Gérer les catégories</button>
            <button class="no-mob-btn pure-button" type="button" onclick="delete_list('{{ list.id }}')">Supprimer la liste</button>
            <button class="no-mob-btn pure-button" type="button" onclick="close_details()">Tout refermer</button>
        </div>
        {% endif %}
    </div>
    <div class="table-resp margint-normal">
        {% if not public %}
        <div class="marginb-normal hidden" id="add-container">
            <hr>
            <div style="max-width: 40em; margin: auto;">
                <form>
                    <h2>Ajouter une tâche :</h2>
                    <label for="new_task_title">Titre :</label>
                    <input class="marginb-normal" type="text" id="new_task_title" style="width: 100%">
                    <label for="new_task_descr">Description :</label>
                    <textarea class="marginb-normal" id="new_task_descr" rows="8" style="width: 100%"></textarea>
                    <label class="margint-normal" for="new_task_parent_task">Est une sous tâche de :</label>
                    <select class="marginb-normal fullwidth" id="new_task_parent_task">
                        <option value="-1"></option>
                    </select>
                    <div class="marginb-normal fullwidth" style="display: flex;">
                        <div style="flex: 1; margin-right: 10px;">
                            <label for="new_task_due_date">Date de fin :</label>
                            <input type="text" id="new_task_due_date" style="width: 100%">
                        </div>
                        <div style="flex: 1; margin-left: 10px;">
                            <label for="new_task_priority">Priorité :</label>
                            <select id="new_task_priority" style="width: 100%;">
                                {% for choice in priority_levels %}
                                {% if choice.0 != 2 %}
                                <option value="{{ choice.0 }}">{{ choice.1 }}</option>
                                {% else %}
                                <option selected value="{{ choice.0 }}">{{ choice.1 }}</option>
                                {% endif %}
                                {% endfor %}
                            </select>
                        </div>
                    </div>
                    <div class="marginb-normal margint-normal fullwidth" id="new_task_categories_container">
                        <label for="new_task_category">Catégorie(s) :</label>
                        <select class="fullwidth" id="new_task_category">
                            <option value="-1"></option>
                        </select>
                    </div>
                    <button class="marginb-normal pure-button" type="button" onclick="add_task_exp('/todo/lists/{{ list.id }}/add_task');">Ajouter une nouvelle tâche</button>
                </form>
            </div>
            <hr>
        </div>
        <div class="marginb-normal hidden" id="add-category-container">
            <hr>
            <div style="max-width: 40em; margin: auto;">
                <h2>Gestion des catégories :</h2>
            </div>
            <div style="max-width: 40em; margin: auto;">
                <h3>Ajouter une catégorie :</h3>
                <form>
                    <label for="new_category_name">Nom :</label>
                    <input class="marginb-normal" type="text" id="new_category_name" style="width: 100%">
                    <button id="add-category-btn" class="marginb-normal pure-button" type="button">Ajouter une nouvelle catégorie</button>
                </form>
            </div>
            <div style="max-width: 40em; margin: auto;">
                <h3>Editer une catégorie :</h3>
                <form>
                    <label for="category_to_edit">Catégorie :</label>
                    <select class="marginb-normal fullwidth" name="category_to_edit" id="category_to_edit">
                        <option value="-1"></option>
                    </select>
                    <label for="edit_category_name">Nouveau nom :</label>
                    <input class="marginb-normal fullwidth" type="text" id="edit_category_name">
                </form>
                <button id="edit_category-btn" class="marginb-normal pure-button" type="button" disabled>
                    Editer la catégorie
                </button>
                <button id="delete_category-btn" class="marginb-normal pure-button" type="button" disabled>
                    Supprimer la catégorie
                </button>
            </div>
            <hr>
        </div>
        {% endif %}
    {% endif %}
        <div class="marginb-normal">
            <table class="fullwidth pure-table pure-table-bordered" style="max-width: 60em; margin: auto;">
                {% if not search and not xhr %}
                <thead>
                    <tr class="low_black_border">
                        <th class="cell c-align">#</th>
                        <th class="cell c-align">Tâche</th>
                        <th class="th-prio cell c-align" style="max-width: 10%">Priorité</th>
                        <th class="cell c-align">Catégorie</th>
                        <th class="th-creat-date cell c-align">Création</th>
                        <th class="th-resolv-date cell c-align">Résolution</th>
                        <th class="th-due-date cell c-align">Échéance</th>
                        {% if not public %}
                        <th class="no-mob-btn cell c-align">
                        </th>
                        {% endif %}
                    </tr>
                    <tr>
                        <th>
                            <input class="fullwidth" size="1" pattern="^[0-9]+$|^$" type="text" name="search_tid" id="input_tid">
                        </th>
                        <th>
                            <input class="fullwidth" size="1" type="text" name="search_tname" id="input_tname">
                        </th>
                        <th class="th-prio">
                            <select class="fullwidth" name="search_tprio" id="select_tprio" >
                                <option value="-1" label=" " selected></option>
                                {% for choice in priority_levels %}
                                <option value="{{ choice.0 }}">{{ choice.1 }}</option>
                                {% endfor %}
                            </select>
                        </th>
                        <th>
                            <select class="fullwidth" name="search_tcategory" id="select_tcategory">
                                <option value="-1" select></option>
                            </select>
                        </th>
                        <th class="th-creat-date">
                            <div class="flexdiv">
                                <select class="flex1 marginr-tiny" name="search_tcmonth" id="select_tcmonth">
                                    <option value="-1" label=" " selected></option>
                                    {% for month in months %}
                                    <option value="{{ month.1 }}">{{ month.0 }}</option>
                                    {% endfor %}
                                </select>
                                <select class="flex1 marginl-tiny" name="search_tcyear" id="select_tcyear">
                                    <option value="-1" label=" " selected></option>
                                    {% for year in creation_years %}
                                    <option value="{{ year }}">{{ year }}</option>
                                    {% endfor %}
                                </select>
                            </div>
                        </th>
                        <th class="th-resolv-date">
                            <div class="flexdiv">
                                <select class="flex1 marginr-tiny" name="search_trmonth" id="select_trmonth">
                                    <option value="-1" label=" " selected></option>
                                    {% for month in months %}
                                    <option value="{{ month.1 }}">{{ month.0 }}</option>
                                    {% endfor %}
                                </select>
                                <select class="flex1 marginl-tiny" name="search_tryear" id="select_tryear">
                                    <option value="-1" label=" " selected></option>
                                    {% for year in resolution_years %}
                                    <option value="{{ year }}">{{ year }}</option>
                                    {% endfor %}
                                </select>
                            </div>
                        </th>
                        <th class="th-due-date">
                            <div class="flexdiv">
                                <select class="flex1 marginr-tiny" name="search_tdmonth" id="select_tdmonth">
                                    <option value="-1" label=" " selected></option>
                                    {% for month in months %}
                                    <option value="{{ month.1 }}">{{ month.0 }}</option>
                                    {% endfor %}
                                </select>
                                <select class="flex1 marginl-tiny" name="search_tdyear" id="select_tdyear">
                                    <option value="-1" label=" " selected></option>
                                    {% for year in deadlines_years %}
                                    <option value="{{ year }}">{{ year }}</option>
                                    {% endfor %}
                                </select>
                            </div>
                        </th>
                        {% if not public %}
                        <th class="no-mob-btn"></th>
                        {% endif %}
                    </tr>
                </thead>
                {% endif %}
                <tbody id="list-container">
                    {% for task in tasks %}
                        <tr id="{{ task.task_no }}" class="nowrap priority_{{ task.priority }}">
                            <td class="cell c-align">
                                {{ task.task_no }}
                            </td>
                            <td id="title_{{ task.task_no }}" class="pointer cell l-align" style="white-space: nowrap;">
                                <span title="{{ task.title }}">{{ task.title|truncatechars:40 }}</span>
                            </td>
                            <td class="td-prio" id="priority_{{ task.task_no }}" class="pointer cell c-align" style="white-space: nowrap; padding-left: 1em; padding-right: 1em;">
                                {{ task.get_priority_display }}
                            </td>
                            <td id="categories_{{ task.task_no }}" class="pointer cell c-align">
                                {{ task.get_displayable_categories }}
                            </td>
                            <td class="td-creat-date pointer cell c-align">
                                {{ task.creation_date|date:"d/m/Y" }}
                            </td>
                            {% if task.is_done %}
                                <td class="td-resolv-date pointer cell c-align" id="resolutiond_{{ task.task_no }}" colspan="2">
                                    Résolu le {{ task.resolution_date|date:"d/m/Y" }} à {{ task.resolution_date|date:"H:i" }}
                                </td>
                            {% else %}
                                <td class="td-resolv-date" id="resolutiond_{{ task.task_no }}" class="pointer cell c-align">
                                {{ task.resolution_date|date:"d/m/Y" }}
                                </td>
                                <td class="td-due-date" id="dued_{{ task.task_no }}" class="pointer cell c-align">
                                    {{ task.due_date|date:"d/m/Y" }}
                                </td>
                            {% endif %}
                            {% if not public %}
                                <td class="no-mob-btn delete pointer cell c-align" style="min-width: 30px;" onclick="del_task('/todo/lists/{{ list.id }}/del_task/{{ task.id }}', {{ task.task_no }});">
                                    <img class="pointer" width="24" height="24"  alt="Delete" src="{% static 'img/icons/garbage_red.svg' %}">
                                </td>
                            {% endif %}
                        </tr>
                        <tr id="task_subline_{{ task.task_no }}" class="hidden b_lightgrey">
                            <td id="task_detail_{{ task.task_no }}" colspan="8">
                                <div class="margint-normal">
                                    <span style="font-size: 1.8em">Tâche #{{ task.task_no }} : {{ task.title }}</span>
                                </div>
                                <div>
                                    <span style="display: inline-block;">
                                        Crée le {{ task.creation_date|date:"d/m/Y" }} à {{ task.creation_date|date:"H:i" }} par <b>{{ task.owner }}</b>
                                    </span>
                                </div>
                                <div>
                                    <span id="task_{{ task.task_no }}_progression_span">
                                        Progression: <b>{{ task.subtasks_progress }}%</b>
                                    </span>
                                </div>
                                <hr>
                                <div class="fullwidth" id="description_{{ task.task_no }}">
                                    {{ task.description|linebreaks|display_urls }}
                                </div>

                                <table>
                                    {% for subtask in task.subtasks %}
                                        <tr class="subtask" id="subtask_{{ subtask.id }}">
                                            {% if subtask.is_done %}
                                                <td><input id="subtask_{{ subtask.id }}_btn" checked type="checkbox"></td>
                                                <td class="strikethrough fullwidth">{{ subtask.title }}</td>
                                            {% else %}
                                                <td><input id="subtask_{{ subtask.id }}_btn" type="checkbox"></td>
                                                <td class="fullwidth">{{ subtask.title }}</td>
                                            {% endif %}
                                        </tr>
                                    {% endfor %}
                                </table>

                                <hr>
                                <div class="margint-normal followups_container" id="followups_{{ task.task_no }}">
                                </div>

                                <label for="followup_{{ task.task_no}}">Ajouter un commentaire :</label>
                                <textarea class="marginb-normal margint-normal fullwidth" id="followup_{{ task.task_no }}"></textarea>
                                <button class="marginr-tiny pure-button pure-button-primary" type="button" id="edit-btn_{{ task.task_no }}">EDITER</button>
                                <button class="marginl-tiny marginr-tiny pure-button pure-button-primary" type="button" id="add_followup-btn_{{ task.task_no }}">
                                    AJOUTER UN COMMENTAIRE
                                </button>
                                {% if not task.is_done %}
                                    {% if not task.is_rejected %}
                                        <button class="marginl-tiny marginr-tiny pure-button pure-button-primary" type="button" id="reject_task-btn_{{ task.task_no }}">
                                            REJETER LA TÂCHE
                                        </button>
                                    {% endif %}
                                    <button class="marginl-tiny pure-button pure-button-primary" type="button" id="close-btn_{{ task.task_no }}">
                                        FERMER LA TÂCHE
                                    </button>
                                {% else %}
                                    <button class="marginl-tiny pure-button pure-button-primary" type="button" id="close-btn_{{ task.task_no }}">
                                        ROUVRIR LA TÂCHE
                                    </button>
                                {% endif %}
                            </td>
                        </tr>
                    {% endfor %}
                    {% if not xhr %}
                </tbody>
            </table>
        </div>
        {% endif %}
    </div>
{% endblock %}